package com.muyu.etl;

import com.alibaba.druid.pool.DruidPooledConnection;
import com.muyu.common.core.constant.SecurityConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.domain.BasicConfigInfo;
import com.muyu.etl.util.factory.DruidUtilsFactory;
import com.muyu.etl.util.service.ConnectionPoolFactory;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import java.sql.SQLException;
import java.util.List;

/**
 * @ClassName AssetClientRunner
 * @Description 描述
 * @Author SaiSai.Liu
 * @Date 2024/5/9 21:26
 */
@Component
@Log4j2
public class AssetClientRunner implements ApplicationRunner {

    @Autowired
    private RemoteAssetService remoteAssetService;
    @Autowired
    private ConnectionPoolFactory connectionPoolFactory;

    @Override
    public void run(ApplicationArguments args) throws ServletException {
        BasicConfigInfo basicConfigInfoSel = new BasicConfigInfo() {{
            setIsTest("1");
        }};
        Result<TableDataInfo<BasicConfigInfo>> result = remoteAssetService.list(basicConfigInfoSel, SecurityConstants.INNER);
        log.info("初始话内容为{}", result);
        List<BasicConfigInfo> rows = result.getData().getRows();
        if (rows.isEmpty()) throw new ServletException("初始化调用失败，无数据");
        log.info(rows);
        int a = 0;
        for (BasicConfigInfo basicConfigInfo : rows) {
            a++;
            log.info("a:{}", a);
            log.warn("接入信息：{}", basicConfigInfo);
            DruidPooledConnection init = null;
            try {
                log.info("初始化开始");
                init = connectionPoolFactory.init(basicConfigInfo);
                log.info("初始化结果：{}", init);
            } catch (Exception e) {
                log.error("初始化异常：{}", e.getMessage());
                //跳过
                continue;
            }
        }
        log.info("初始化完成");
        log.info("连接池：：{}", DruidUtilsFactory.map);

    }
}
