package com.muyu.etl;

import com.muyu.etl.factory.RemoteAssetFallbackFactory;
import com.muyu.common.core.constant.SecurityConstants;
import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.domain.BasicConfigInfo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.context.annotation.Bean;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;

/**
 * 用户服务
 *
 * @author muyu
 */
@FeignClient(contextId = "remoteAssetService",
        value = ServiceNameConstants.ETL_SERVICE,
        fallbackFactory = RemoteAssetFallbackFactory.class)
public interface RemoteAssetService {
    /**
     * 获取所有接入信息信息
     *
     * @param basicConfigInfo 请求参数
     * @param source          请求来源
     * @return 结果
     */
    @PostMapping("/info/list")
    public Result<TableDataInfo<BasicConfigInfo>> list(@RequestBody BasicConfigInfo basicConfigInfo, @RequestHeader(SecurityConstants.FROM_SOURCE) String source);


}
