package com.muyu.etl.factory;

import com.muyu.etl.RemoteAssetService;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.domain.BasicConfigInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * 用户服务降级处理
 *
 * @author muyu
 */
@Component
public class RemoteAssetFallbackFactory implements FallbackFactory<RemoteAssetService> {
    private static final Logger log = LoggerFactory.getLogger(RemoteAssetFallbackFactory.class);

    @Override
    public RemoteAssetService create(Throwable throwable) {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteAssetService() {

            @Override
            public Result<TableDataInfo<BasicConfigInfo>> list(BasicConfigInfo basicConfigInfo, String source) {
                return Result.error("查询接入信息失败,"+throwable.getMessage());
            }
        };
    }
}
